<template>
    <el-dialog
      v-model="open"
      :title="title"
      width="800px"
      append-to-body
    >
      <el-form ref="algRef" :model="form" :rules="rules" label-width="80px">
            <el-row>
               <el-col :span="12">
                <el-form-item label="算法名称" prop="postName">
                  <el-input v-model="form.postName" placeholder="请输入岗位名称" />
                </el-form-item>
               </el-col>
               <el-col :span="12">
                <el-form-item label="算法英文" prop="postCode">
                  <el-input v-model="form.postCode" placeholder="请输入编码名称" />
                </el-form-item>
               </el-col>
            </el-row>
            <el-row>
               <el-col :span="12">
                <el-form-item label="硬件平台" prop="postSort">
                  <el-input v-model="form.yjpt" placeholder="请输入编码名称"  />
                </el-form-item>
               </el-col>
               <el-col :span="12">
                <el-form-item label="告警等级" prop="status">
                  <el-input v-model="form.gjdj" placeholder="请输入告警等级"   />
                </el-form-item>
               </el-col>
            </el-row>
            <el-row>
               <el-col :span="12">
                <el-form-item label="备注" prop="remark">
                  <el-input v-model="form.remark" type="textarea"  :rows="8" placeholder="请输入内容" />
                </el-form-item>
               </el-col>
               <el-col :span="12">
                <el-form-item label="卡片图片" prop="status">
                  <ImageUpload />
                </el-form-item>
               </el-col>
            </el-row>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
            <el-button type="primary" @click="submitForm">确 定</el-button>
            <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
</template>

<script setup>
import { listPost, addPost, delPost, getPost, updatePost } from "@/api/system/post";
const { proxy } = getCurrentInstance();
const emit = defineEmits();
const open = ref(false);
const title = ref("");
const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    postCode: undefined,
    postName: undefined,
    status: undefined
  },
  rules: {
    postName: [{ required: true, message: "岗位名称不能为空", trigger: "blur" }],
    postCode: [{ required: true, message: "岗位编码不能为空", trigger: "blur" }],
    postSort: [{ required: true, message: "岗位顺序不能为空", trigger: "blur" }],
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 表单重置 */
function reset() {
  form.value = {
    postId: undefined,
    postCode: undefined,
    postName: undefined,
    postSort: 0,
    status: "0",
    remark: undefined
  };
  proxy.resetForm("algRef");
}


/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加算法";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const postId = row.postId || ids.value;
  getPost(postId).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改算法";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["algRef"].validate(valid => {
    if (valid) {
      if (form.value.postId != undefined) {
        updatePost(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addPost(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}
/** 取消按钮 */
function cancel() {
  open.value = false;
  reset();
}
defineExpose({ handleAdd , handleUpdate })
</script>

<style scoped lang="scss">
// .el-upload--picture-card 控制加号部分
:deep(.hide .el-upload--picture-card) {
    display: none;
}
</style>